***Übungsaufgaben 


version 15 //Versionsnummer
use ESS8DEm.dta, clear //Datensatz einlesen
set more off

* Aufgabe 1
* Zeilenvariable: intewde, Spaltenvariable vote: durch das Gebiet soll Wahlbeteiligung erklärt werden

* Aufgabe 1a
* Fehlende Werte ausschließen, Variablenwerte mit codebook, label list oder tabulate anzeigen lassen

label list vote 
clonevar vote_n=vote if vote < 3
ta vote_n intewde

* Aufgabe 1b

ta vote_n intewde, column

* Aufgabe 1c: Ostdeutsche gehen etwas seltener zur Wahl als Westdeutsche, die Differenz beträgt -6,28

* Aufgabe 1d

display 80.92-87.20

* Der Wert der Prozentsatzdifferenz beträgt -6,28 Prozentpunkte

* Aufgabe 1e

ta vote_n intewde, V nofreq

* Phi beträgt -0,0834, es wird der Betrag interpretiert: 0,0834, zeigt einen geringen Zusammenhang auf

* Aufgabe 1d

ta vote_n intewde, nof chi2

* Pearson chi2(1) =  17.3000   Pr = 0.000: Chi-Quadrat gibt an, dass ein Zusammenhang existiert, Größe nicht als Zusammenhangsmaß interprtierrbar
* Anhand des p-Werts (Pr) lässt sich ablesen, dass der geringe Zusammenhang (Phi) hochsignifikant (***) ist (Irrtumswahrscheinlichkeit weniger 0,1 % )

* Aufgabe 2
* Fehlende Werte ausschließen, Variablenwerte mit codebook, label list oder tabulate anzeigen lassen

codebook hincfel stflife /*für stflife mit label list Kodierung anschauen*/
label list stflife
clonevar hincfel_n=hincfel if hincfel < 5
clonevar stflife_n= stflife if stflife < 11
ta hincfel_n stflife_n, gamma taub nofreq
// Ergebnis: gamma =  -0.4436  ASE = 0.020; Kendall's tau-b =  -0.3143  ASE = 0.015
// Beide Maßzahlen zeigen mittleren, negativen Zusammenhang auf: 
// Je schlechter das Haushaltseinkommen beurteilt wird, desto negativer fällt die Lebenszufriedenheit aus bzw. 
// Je geringer die Lebenszufriedenheit ausfällt, desto negativer wird das Haushaltseinkommen beurteilt 
display -0.4436/0.020 // Teststatistik berechnen |-22.18| ist kleiner als 3,32: hochsignifikant (0,1 % Irrtumswahrscheinlichkeit)
display -0.3143/0.015 // |-20.953333| hochsignifikant

* Aufgabe 3

recode stflife_n (0 1=1)(2 3=2)(4 5 6=3)(7 8=4)(9 10=5), gen(stflife_r)
label define stflife_rlb 1"sehr zufrieden" 2"zufrieden" 3"weder zufrieden noch unzufrieden" 4"weniger zufrieden" 5"gar nicht zufrieden"
label values stflife_r stflife_rlb
ta stflife_r


* Aufgabe 3a

ta hincfel_n stflife_r, nof gamma t
// Ergebnis: gamma =  -0.5035  ASE = 0.022; Kendall's tau-b =  -0.3263  ASE = 0.016
// Gamma: mittlerer bis starker Zusammenhang, stärker als vor der Zusammenfassung der Werte; tau-b fast unverändert
display -0.5035/0.022 // Teststatistik berechnen
display -0.3263/0.016
// Beide Werte sind größer als 3,32 somit ist der Zusammenhang hochsignifikant

* Aufgabe 3b
// Gamma ist weniger geeignet als tau-b, da sein Wert den Zusammenhang eher überschätzt und beim Zusammenfassen von Werten größer wird 

* Aufgabe 4a,b
* Fehlende Werte ausschließen, Variablenwerte mit codebook, label list oder tabulate anzeigen lassen

tab1 freehms gndr,nolabel
clonevar freehms_n=freehms if freehms < 6
ta freehms_n gndr, column V chi2
// Cramér's V =   0.1550: Leichter Zusammenhang zwischen dem Geschlecht und der Einstellung: Männer stimmen etwas häufiger dagegen (siehe Prozentwerte)
// Pearson chi2(4) =  68.2486   Pr = 0.000: Das Ergebnis ist hochsignifikant

* Aufgabe 4c
* Dummyvariablen für frehms erzeugen 
ta freehms_n, gen(freehms_d)
tab1 freehms_d*

*Gruppiertes Balkendiagramm
graph bar freehms_d*, over(gndr) percent blabel(bar) bargap(20)


*Alternative gestapeltes Balkendiagramm
graph bar freehms_d*, over(gndr) stack percent legend( label(1 "Agree strongly") label(2 "Agree") label(3 "Neither agree nor disagree") label(4 "Disagree") label(5 "Disagree strongly"))

* Aufgabe 5a
** Fehlende Werte der Internetnutzungsdauer ausschließen
label list netustm
clonevar netustm_n=netustm if netustm < 6666
tabulate gndr, summarize(netustm_n)
table gndr, contents(mean netustm_n sd netustm_n)

* Aufgabe 5b

graph bar netustm_n, over(gndr) blabel(bar)

*Alternative
graph box netustm_n, over(gndr) 





