*********************Interaktionseffekte
version 15
set more off
use allbus2012_red.dta, clear 

codebook v75 v76 v77 v78 v100 v220

mvdecode v75 v76 v77 v78, mv(0=.d\ 99=.d)
mvdecode v220, mv(999=.)
mvdecode v100, mv(8=.a\9=.d)
gen index=(v75+v76+v77+v78)/4
label variable index "Index Ausländerfeindlichkeit"
label define aus_lb 1"nicht ausländerfeindlich" 7"sehr ausländerfeindlich"
label values index aus_lb

*Dummies: werden in der anderen Variante nicht benötigt
gen dPost=1 if v100==1
replace dPost=0 if v100>1 & !missing(v100)
gen dMat=1 if v100==4 
replace dMat=0 if v100<4 
tab1 v100 dPost dMat
label variable dPost "Postmaterialistinnen" 
label variable dMat "Materialisten"
label define post_lb 1"1 Postmaterialistinnen" 0"0 Mischtyp"
label define mat_lb 1"1 Materialisten" 0"0 Mischtyp"
label values dPost post_lb
label values dMat mat_lb

*Umcodieren der Variable, Referenz sollen Mischtypen sein
recode v100(1=2)(2/3=1)(4=3)(.c/.d=.)(8/9=.), gen(v100r)
label variable v100r "Inglehardt-Index"
label define v100r_lb 1"Mischtyp" 2"Postmaterialistinnen" 3"Materialisten"
label values v100r v100r_lb
ta v100r

keep index v220 v100 v101 index dPost dMat v100r 
